% ************************************************************************%
%  BBRB for LNM diagnosis on cross one
% Author    Zhi-Guo Zhou, Fang Liu et al.                                 *
% Date    : 20th,Aug,2013                                                 *
% Address   School of computer science and techology                      *
%           Xidian Univeristy                                             *
%                                                                         *
%  Copyright (c) 2013 by Zhi-Guo Zhou, Fang Liu et al.                    *
% ************************************************************************%
% initializing BRB1
    A=[0,5,6,7,8,9,10,12,17,21,50];%Reference point for LN size
    B=[0,5,7,9,12,16,20,30,50];   %Reference point for LN number
    N=3;     %the number of BRB1's output
    M=2;     %the number of BRB1's atrribute
    L=size(A,2)*size(B,2); % the number of belief 
    var=M+L+N*L; % the number of variables
    load init_BRB1
    load BRB1_train
    ec_num=50;% The maximum number of evolutionary generation
    init_train=BRB1_train;
    train_data=init_train';
    sam_train_data=train_data((1:2),:);
    ind_train_data=train_data(3,:);
    % optimizing BRB1 using CSA
    x=clonal_selection1(sam_train_data,ind_train_data,init_BRB1,M,N,L,A,B,ec_num);
    display('Optimizating BRB1 is finished!');
    
    %Initilizing BRB2
    A1=[0,5,6,7,8,10,14,20,50];   %The reference point of LN size
    B1=[0,6,8,10,12,13,20,50];  %The reference point of LN number
    N1=2;    %The number of BRB2's output
    M1=2;    %The number of BRB2's attribute
    L1=size(A1,2)*size(B1,2);
    load init_BRB2
    load BRB2_train
    ec_num1=50;%The maximum number of evolutionary generation
    var1=M1+L1+N1*L1;% the number of variables
    init_train1=BRB2_train';
    % training data
    train_data1=init_train1';
    sam_train_data1=train_data1((1:2),:);
    ind_train_data1=train_data1(3,:);
    % optimizing BRB2 using CSA
    x1=clonal_selection2(sam_train_data1,ind_train_data1,init_BRB2,M1,N1,L1,A1,B1,ec_num1);
    display('Optimizating BRB2 is finished!');
    
    %generating new BBRB model
    % BRB1
    x=abs(x);
    for i=1:M
        deta(i)=x(i);
    end
    sta=x(M+1:L+M);
    for j=1:L
        deta2(j,:)=deta;
    end
    for i=1:L
        for j=1:N
            beta1(i,j)=x(L+M+N*(i-1)+j);
        end
    end
    %BRB2
    x1=abs(x1);
    for i=1:M1
        deta1(i)=x1(i);
    end
    sta1=x1(M1+1:L1+M1);
    for j=1:L1
        deta3(j,:)=deta1;
    end
    for i=1:L1
        for j=1:N1
            beta2(i,j)=x1(L1+M1+N1*(i-1)+j);
        end
    end
    %test stage
    load test_data
    init_test=test_data;
    test_data=init_test';
    test_data_sam=test_data((1:2),:);
    test_data_ind=test_data(3,:);

    % first layer
    for t=1:size(test_data,2)
        T(:,:,t)=Reference(A,B,test_data_sam(:,t));
        Bet1(t,:)=Evidential(sta,T(:,:,t),deta2,beta1);
    end
    for p=1:size(test_data,2)
        [C,I]=max(Bet1(p,:));
        output_label(p)=I;
    end
    %second layer
    new_test_data=[];
    tmp=1;
    for p=1:size(test_data,2);
        if output_label(p)==2
            new_test_data(:,tmp)=test_data(:,p);
            tmp=tmp+1;
        end
    end
    for t=1:size(new_test_data,2)
        T1(:,:,t)=Reference(A1,B1,new_test_data(:,t));
        Bet2(t,:)=Evidential(sta1,T1(:,:,t),deta3,beta2);
    end
    for p=1:size(new_test_data,2)
        [C1,I1]=max(Bet2(p,:));
        output_label1(p)=I1;
    end
    % intergrating the output of two layers
    fin_out_label=[];
    j=1;
    for i1=1:size(test_data,2)
        if output_label(i1)==1
            fin_out_label(i1)=1;
        end
        if output_label(i1)==3
            fin_out_label(i1)=4;
        end
        if output_label(i1)==2
            if j<size(new_test_data,2)
                j=j+1;
            end
            if output_label1(j)==1
                fin_out_label(i1)=2;
            end
        if output_label1(j)==2        
            fin_out_label(i1)=3;
        end
        end
    end   
  % testing the correct rate
corr_num=0;
for p=1:size(test_data,2)
    if fin_out_label(p)==test_data_ind(p)
        corr_num=corr_num+1;
    end
end
%show results
test_data_num=size(test_data,2);
corr_rate=corr_num/test_data_num;
CM=cal_CM(fin_out_label,test_data_ind,4);
display(corr_rate);
display(CM);
display('The program is finished!');
    
    